/*
    Random linux defines for windows

    Hacked to work in windows 2004 Andrew de Quincey

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef LINUXSTUFF_H
#define LINUXSTUFF_H 1

#include <stdio.h>

#define DEB_I2C printf
#define INFO printf
#define printk printf
#define KERN_WARNING /**/

#define ENOMEM 1
#define EIO 2
#define EREMOTEIO 3

typedef unsigned long u32;
typedef unsigned short __u16;
typedef unsigned char __u8;
typedef unsigned char u8;

struct i2c_msg {
	__u16 addr;	/* slave address			*/
 	__u16 flags;		
#define I2C_M_TEN	0x10	/* we have a ten bit chip address	*/
#define I2C_M_RD	0x01
#define I2C_M_NOSTART	0x4000
#define I2C_M_REV_DIR_ADDR	0x2000
#define I2C_M_IGNORE_NAK	0x1000
#define I2C_M_NO_RD_ACK		0x0800
 	__u16 len;		/* msg length				*/
 	__u8 *buf;		/* pointer to msg data			*/
};

#define PAGE_SIZE 4096

#define PCI_CLASS_REVISION 0x08

#endif
